<div class="content d-flex flex-column flex-column-fluid" id="kt_content">
  <div class="subheader py-2 py-lg-4 subheader-solid" id="kt_subheader">
    <div
      class="container-fluid d-flex align-items-center justify-content-between flex-wrap flex-sm-nowrap"
    >
      <!--begin::Info-->
      <div class="d-flex align-items-center flex-wrap mr-1">
        <!--begin::Page Heading-->
        <div class="d-flex align-items-baseline mr-5">
          <!--begin::Page Title-->
          <h5 class="text-dark font-weight-bold my-2 mr-5">Utilisateurs</h5>
          <div
            class="subheader-separator subheader-separator-ver mt-2 mb-2 mr-5 bg-gray-200"
          >
            <span class="ml-4"> {{ data.length }}</span>
          </div>
          <div class="d-flex align-items-center" id="kt_subheader_search">
            <span class="text-dark-50 font-weight-bold" id="kt_subheader_total"
              >total
            </span>
          </div>
        </div>
      </div>
      <div class="d-flex align-items-center">
        <!--begin::Actions-->
        <button class="btn btn-sm btn-primary" (click)="openAddModal(content)">
          Nouveau
        </button>
      </div>
    </div>
  </div>
  <div class="d-flex flex-column-fluid">
    <div class="container">
      <div class="card card-custom" [ngClass]="cssClasses">
        <!-- Header -->
        <div class="card-header bg-gray-200 p-4 border-0 pt-5">
          <h3 class="card-title align-items-start flex-column">
            <select
              name="filter"
              class="form-control"
              id="filter"
              (change)="filtter($event)"
            >
              <option value="" disabled selected>Filtrer</option>
              <option value="false">Actif</option>
              <option value="true">Inactif</option>
            </select>
          </h3>
          <div class="card-toolbar">
            <ul class="nav nav-pills ml-4 nav-pills-sm nav-dark-75">
              <li class="nav-item">
                <form>
                  <div class="form-group form-inline">
                    <input
                      class="form-control form-control-sm"
                      placeholder="Rechercher...."
                      type="text"
                      [(ngModel)]="searchText"
                      name="searchText"
                      (keyup)="search()"
                    />
                  </div>
                </form>
              </li>
              <li class="nav-item"></li>
            </ul>
          </div>
        </div>
        <!-- Body -->
        <div class="card-body pt-3 pb-0">
          <!--begin::Table-->
          <div class="table-responsive">
            <table
              class="table table-separate datatable table-head-custom table-vertical-center"
              id="kt_datatable"
            >
              <thead>
                <tr>
                  <th scope="col">N°</th>
                  <th scope="col">Nom complet</th>
                  <th scope="col">Email</th>
                  <th scope="col">Contact</th>
                  <th scope="col">Ecole</th>
                  <th scope="col">Role</th>
                  <th class="text-center">Status</th>
                  <th class="text-center">Actions</th>
                </tr>
              </thead>
              <tbody>
                <tr
                  *ngFor="
                    let el of data
                      | slice
                        : (page - 1) * pageSize
                        : (page - 1) * pageSize + pageSize;
                    index as i
                  "
                >
                  <td>{{ i + 1 }}</td>
                  <td>{{ el.username }}</td>
                  <td>
                    <ngb-highlight
                      [result]="el.email"
                      [term]="searchText"
                    ></ngb-highlight>
                  </td>
                  <td>
                    {{ el.phone }}
                  </td>
                  <td *ngIf="el.school">
                    {{ el.school.name }}
                  </td>
                  <td *ngIf="!el.school">
                    {{ "N/A" }}
                  </td>
                  <td>
                    {{ el.role }}
                  </td>
                  <td class="text-center">
                    <span
                      class="label label-lg label-light-success label-inline"
                      *ngIf="el.is_active"
                      >Actif</span
                    >
                    <span
                      class="label label-lg label-light-danger label-inline"
                      *ngIf="!el.is_active"
                      >Inactif</span
                    >
                  </td>
                  <td class="text-center pr-0">
                    <button
                      (click)="openEditModal(contentU, el)"
                      class="btn btn-icon btn-clean btn-sm"
                    >
                      <i class="la la-pen"></i>
                    </button>
                    <button
                      *ngIf="el.is_active"
                      (click)="lock(el.id, i)"
                      class="btn btn-icon btn-clean btn-sm mx-3"
                    >
                      <i class="la la-lock"></i>
                    </button>

                    <button
                      *ngIf="!el.is_active"
                      (click)="unlock(el.id, i)"
                      class="btn btn-icon btn-clean btn-sm mx-3"
                    >
                      <i class="la la-lock-open"></i>
                    </button>
                    <button
                      (click)="archive(el.code, i)"
                      class="btn btn-icon btn-clean btn-sm"
                    >
                      <i class="la la-trash"></i>
                    </button>
                  </td>
                </tr>
                <tr *ngIf="data.length == 0">
                  <td colspan="6" class="text-center bg-secondary">
                    Aucun elements
                  </td>
                </tr>
              </tbody>
            </table>
            <div class="d-flex justify-content-between p-2">
              <ngb-pagination
                class=""
                [collectionSize]="collectionSize"
                [(page)]="page"
                [maxSize]="5"
                [pageSize]="pageSize"
                [rotate]="true"
                [ellipses]="false"
                [boundaryLinks]="true"
              >
              </ngb-pagination>
              <select
                class="custom-select custom-select-sm float-right"
                style="width: auto"
                [(ngModel)]="pageSize"
              >
                <option selected disabled>Filtrer</option>
                <option [ngValue]="3">3 elements par page</option>
                <option [ngValue]="5">5 elements par par page</option>
                <option [ngValue]="10">10 elements par par page</option>
              </select>
            </div>
          </div>
          <!--end::Table-->
        </div>
        <ng-template #content let-modal>
          <form #newForm="ngForm" (ngSubmit)="create(newForm.value)">
            <div class="modal-header">
              <h4 class="modal-title" id="modal-basic-title">Nouvel ajout</h4>
              <button
                type="button"
                class="close"
                aria-label="Close"
                (click)="modal.dismiss('Cross click')"
              >
                <i class="la la-close font-size-h3"></i>
              </button>
            </div>
            <div class="modal-body">
              <div *ngIf="error" class="alert alert-danger my-1 alert-rounded">
                {{ error }}
                <button
                  type="button"
                  class="close"
                  data-dismiss="alert"
                  aria-label="Close"
                >
                  <span aria-hidden="true">×</span>
                </button>
              </div>
              <div class="form-group">
                <input
                  type="hidden"
                  name="id"
                  [(ngModel)]="selected_data.id"
                  #id="ngModel"
                />
                <label>Nom</label>
                <input
                  class="form-control"
                  #last_name="ngModel"
                  maxlength="250"
                  required
                  name="last_name"
                  [(ngModel)]="selected_data.last_name"
                />
                <span
                  *ngIf="
                    last_name.invalid && (last_name.dirty || last_name.touched)
                  "
                  class="text-danger"
                >
                  <small *ngIf="last_name.errors?.required">
                    Le nom de l'utilisateur est requis.
                  </small>
                  <small *ngIf="last_name.errors.maxlength">
                    Pas plus de 250 caractères pour le nom de l'utilisateur.
                  </small>
                </span>
              </div>
              <div class="form-group">
                <label>Prénom</label>
                <input
                  class="form-control"
                  #first_name="ngModel"
                  maxlength="250"
                  required
                  name="first_name"
                  [(ngModel)]="selected_data.first_name"
                />
                <span
                  *ngIf="
                    first_name.invalid &&
                    (first_name.dirty || first_name.touched)
                  "
                  class="text-danger"
                >
                  <small *ngIf="first_name.errors?.required">
                    Le prénom de l'utilisateur est requis.
                  </small>
                  <small *ngIf="first_name.errors.maxlength">
                    Pas plus de 250 caractères pour le prénom de l'utilisateur.
                  </small>
                </span>
              </div>
              <div class="form-group">
                <label>Email</label>
                <input
                  class="form-control"
                  type="email"
                  required
                  #email="ngModel"
                  name="email"
                  [(ngModel)]="selected_data.email"
                  pattern="^[a-z0-9._%+-]+@[a-z0-9.-]+\.[a-z]{2,4}$"
                />
                <span
                  *ngIf="email.invalid && (email.dirty || email.touched)"
                  class="text-danger"
                >
                  <small *ngIf="email.errors?.required">
                    Email est requis.
                  </small>
                  <small *ngIf="email.errors?.pattern"> Email invalide. </small>
                </span>
              </div>
              <div class="form-group">
                <label>Contact</label>
                <input
                  class="form-control"
                  type="number"
                  required
                  #phone="ngModel"
                  name="phone"
                  [(ngModel)]="selected_data.phone"
                />
                <span
                  *ngIf="phone.invalid && (phone.dirty || phone.touched)"
                  class="text-danger"
                >
                  <small *ngIf="phone.errors?.required">
                    Le contact est requis
                  </small>
                  <small *ngIf="phone.errors?.pattern"> Contact invalid </small>
                </span>
              </div>
              <!--Ecoles-->
              <div class="form-group">
                <label>Ecole </label>
                <ng-select
                  name="school"
                  placeholder="Choisissez une école"
                  [items]="schools"
                  [(ngModel)]="selectedSchool"
                  bindLabel="name"
                  bindValue="id"
                >
                </ng-select>
              </div>
              <!--Roles-->
              <div class="form-group">
                <label>Role </label>
                <ng-select
                  name="bookrole"
                  placeholder="Choisissez un role"
                  [items]="items"
                  [(ngModel)]="selectedItems"
                  bindLabel="name"
                  bindValue="id"
                >
                </ng-select>
              </div>
            </div>
            <div class="modal-footer">
              <button
                type="button"
                class="btn btn-outline-dark"
                [disabled]="!newForm.form.valid"
                type="submit"
              >
                Sauvegarder
              </button>
            </div>
          </form>
        </ng-template>
        <ng-template #contentU let-modal>
          <form #newForm="ngForm" (ngSubmit)="edit(newForm.value)">
            <div class="modal-header">
              <h4 class="modal-title" id="modal-basic-title">
                Nouvelle modification
              </h4>
              <button
                type="button"
                class="close"
                aria-label="Close"
                (click)="modal.dismiss('Cross click')"
              >
                <i class="la la-close font-size-h3"></i>
              </button>
            </div>
            <div class="modal-body">
              <div *ngIf="error" class="alert alert-danger my-1 alert-rounded">
                {{ error }}
                <button
                  type="button"
                  class="close"
                  data-dismiss="alert"
                  aria-label="Close"
                >
                  <span aria-hidden="true">×</span>
                </button>
              </div>
              <div class="form-group">
                <input
                  type="hidden"
                  name="id"
                  [(ngModel)]="selected_data.id"
                  #id="ngModel"
                />
                <label>Nom</label>
                <input
                  class="form-control"
                  #last_name="ngModel"
                  maxlength="250"
                  required
                  name="last_name"
                  [(ngModel)]="selected_data.last_name"
                />
                <span
                  *ngIf="
                    last_name.invalid && (last_name.dirty || last_name.touched)
                  "
                  class="text-danger"
                >
                  <small *ngIf="last_name.errors?.required">
                    Le nom de l'utilisateur est requis.
                  </small>
                  <small *ngIf="last_name.errors.maxlength">
                    Pas plus de 250 caractères pour le nom de l'utilisateur.
                  </small>
                </span>
              </div>
              <div class="form-group">
                <label>Prénom</label>
                <input
                  class="form-control"
                  #first_name="ngModel"
                  maxlength="250"
                  required
                  name="first_name"
                  [(ngModel)]="selected_data.first_name"
                />
                <span
                  *ngIf="
                    first_name.invalid &&
                    (first_name.dirty || first_name.touched)
                  "
                  class="text-danger"
                >
                  <small *ngIf="first_name.errors?.required">
                    Le prénom de l'utilisateur est requis.
                  </small>
                  <small *ngIf="first_name.errors.maxlength">
                    Pas plus de 250 caractères pour le prénom de l'utilisateur.
                  </small>
                </span>
              </div>
              <div class="form-group">
                <label>Email</label>
                <input
                  class="form-control"
                  type="email"
                  required
                  #email="ngModel"
                  name="email"
                  [(ngModel)]="selected_data.email"
                  pattern="^[a-z0-9._%+-]+@[a-z0-9.-]+\.[a-z]{2,4}$"
                />
                <span
                  *ngIf="email.invalid && (email.dirty || email.touched)"
                  class="text-danger"
                >
                  <small *ngIf="email.errors?.required">
                    Email est requis.
                  </small>
                  <small *ngIf="email.errors?.pattern"> Email invalide. </small>
                </span>
              </div>
              <div class="form-group">
                <label>Contact</label>
                <input
                  class="form-control"
                  type="number"
                  required
                  #phone="ngModel"
                  name="phone"
                  [(ngModel)]="selected_data.phone"
                />
                <span
                  *ngIf="phone.invalid && (phone.dirty || phone.touched)"
                  class="text-danger"
                >
                  <small *ngIf="phone.errors?.required">
                    Le contact est requis
                  </small>
                  <small *ngIf="phone.errors?.pattern"> Contact invalid </small>
                </span>
              </div>
              <!--Ecoles-->
              <div class="form-group">
                <label>Ecole </label>
                <ng-select
                  name="school"
                  placeholder="{{selectedSchool}}"
                  [items]="schools"
                  [(ngModel)]="selectedSchool"
                  bindLabel="name"
                  bindValue="id"
                >
                </ng-select>
              </div>

              <!--Roles-->
              <div class="form-group">
                <label>Role </label>
                <ng-select
                  name="bookrole"
                  placeholder="{{selectedItems}}"
                  [items]="items"
                  [(ngModel)]="selectedItems"
                  bindLabel="name"
                  bindValue="id"
                >
                </ng-select>
              </div>
            </div>
            <div class="modal-footer">
              <button
                type="button"
                class="btn btn-outline-dark"
                [disabled]="!newForm.form.valid"
                type="submit"
              >
                Sauvegarder
              </button>
            </div>
          </form>
        </ng-template>
      </div>
    </div>
  </div>
</div>
